package nl.pcactive.gfx;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.URL;
/**
 * Title:        GFX
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      Pc-Active
 * @author Benny Lootens
 * @version 1.0
 */

public class Kikker extends Applet {
  boolean isStandalone = false;
   private URL bgURL = null;
  private Image bgIMG = null;
  private Image[] sprite = new Image[4];
  private URL[] spriteURL = new URL[4];

  /**Get a parameter value*/
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  private void delay(int millis) {
    try { Thread.sleep(millis); } catch(Exception ignored) {}
  }

  /**Construct the applet*/
  public Kikker() {
  }
  /**Initialize the applet*/
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception {
    bgURL = ClassLoader.getSystemResource("shots/bg.gif");
    bgIMG = getImage(bgURL);

    for (int i=0; i<4; i++) {
      spriteURL[i] = ClassLoader.getSystemResource("shots/"+(i+1)+".gif");
      sprite[i] = getImage(spriteURL[i]);
    }
  }

  public void paint(Graphics g) {
    g.drawImage(bgIMG,0,0,400,300,Color.white,this);

    for (int x=0; x<400; x++) {
      g.drawImage(bgIMG,0,0,400,300,Color.white,this);
      double angle=((double)x) / 20;
      int y = (int) (Math.abs(Math.sin(angle))*80);
      g.drawImage(sprite[2],x,80-y,this);
      delay(25);
    }
    System.exit(0);
  }

  /**Start the applet*/
  public void start() {
  }
  /**Stop the applet*/
  public void stop() {
  }
  /**Destroy the applet*/
  public void destroy() {
  }
  /**Get Applet information*/
  public String getAppletInfo() {
    return "Kikker";
  }
  /**Get parameter info*/
  public String[][] getParameterInfo() {
    return null;
  }
  /**Main method*/
  public static void main(String[] args) {
    Kikker applet = new Kikker();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame() {
      protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("Kikker");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(400,320);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }
}